//----------------------------------------------------------------------------------
//		IIR_3DNRvOC
//----------------------------------------------------------------------------------
/*
Borland C++ Compiler 5.5ɂăRpCB
R}hCIvV
BCC32 -tWD -O1 -O2 iir_3dnr.cpp
*/
#include <windows.h>
#include <string.h>
#include "filter.h"
#include "mvec.cpp"
#include "fwht.cpp"


//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------
int FRAME = -10;
PIXEL_YC* Bef_flame;

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	6														//	gbNo[̐
TCHAR	*track_name[] =		{	"Px",	"F",	"臒l",	"Ka",	"SC_level",	"Kb",	};	//	gbNo[̖O
int		track_default[] =	{	30,	15,	0,	0,	20,	0,	};	//	gbNo[̏l
int		track_s[] =			{	1,	0,	0,	0,	1,	0,	};	//	gbNo[̉l
int		track_e[] =			{	+100,	+100,	+300,	+100,	+50,	+100,	};	//	gbNo[̏l

#define	CHECK_N	1														//	`FbN{bNX̐
TCHAR	*check_name[] = 	{	"L[t[}(Ka)",	};							//	`FbN{bNX̖O
int		check_default[] = 	{	0,	};							//	`FbN{bNX̏l (l01)

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"IIR_3DNR",			//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	check_name,					//	`FbN{bNX̖OSւ̃|C^
	check_default,				//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	func_init,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_exit,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_WndProc,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"IIR_3DNR ver0.04b by HK",			//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}
//---------------------------------------------------------------------
//		JnɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp )
{
	make_motion_lookup_table();
	return TRUE;
}
//---------------------------------------------------------------------
//		IɌĂ΂֐
//---------------------------------------------------------------------
BOOL	func_exit( FILTER *fp )
{
	delete[] Bef_flame;
	return TRUE;
}
//---------------------------------------------------------------------
//		YCbCb֐
//---------------------------------------------------------------------
inline void SET_YCbCr(FILTER_PROC_INFO* fpip)
{
	delete[] Bef_flame;
	Bef_flame = new PIXEL_YC[fpip->max_w*fpip->h];
	memcpy(Bef_flame, fpip->ycp_edit, sizeof(PIXEL_YC)*fpip->max_w*fpip->h);
}
//---------------------------------------------------------------------
//		Px8rbgɃVtg֐
//---------------------------------------------------------------------
void shift_to_eight_bit( PIXEL_YC* ycp, unsigned char* luma, int w, int max_w, int h )
{
	int skip = max_w-w;
	for(int y=0;y<h;y++){
		for(int x=0;x<w;x++) {
			if(ycp->y & 0xf000)
				*luma = (ycp->y < 0) ? 0 : 255;
			else
				*luma = ycp->y >>4 ;
			ycp++;
			luma++;
		}
		ycp += skip;
	}
}
//---------------------------------------------------------------------
//		Px3DNR֐
//---------------------------------------------------------------------
inline void IIR_3DYNR(short& current_Y, short Bef_Y, int str)
{
	long int minus;
	long int square;
	minus = (current_Y-Bef_Y)>>4;
	square = minus * minus;	//powdouble^ɕϊ̂łœ
	current_Y = short( (current_Y*square + Bef_Y*str) / (square+str) );
//current_Y = Bef_Y;
}
//---------------------------------------------------------------------
//		F3DNR֐
//---------------------------------------------------------------------
inline void IIR_3DCNR(short& current_C, short Bef_C, int str)
{
	int C_plus, NRC_plus;
	long int minus, square;
	minus = (current_C-Bef_C)>>4;
	square = minus * minus;
	current_C = short( (current_C*square+ Bef_C*str) / (square+str) );
//current_C =Bef_C;
}
//---------------------------------------------------------------------
//		mCYx␳֐
//---------------------------------------------------------------------
inline void set_str(PIXEL_YC *ycp, PIXEL_YC *Bef_ycp, int y_str, int c_str, int& y_str_temp, int& c_str_temp, int threshold)
{
	int temp = (( abs(ycp->y-Bef_ycp->y) + ((abs(ycp->cb-Bef_ycp->cb)+abs(ycp->cr-Bef_ycp->cr))<<1) )<<7 )/threshold;
	if(temp){
		y_str_temp = ((y_str<<7)/temp)+1;
		c_str_temp = ((c_str<<7)/temp);
		if(y_str_temp>200)
			y_str_temp = 200;
		if(c_str_temp>200)
			c_str_temp = 200;
	}else{
		y_str_temp = 1;
		c_str_temp = 0;
	}
}
//---------------------------------------------------------------------
//		IIR_3DNR֐
//---------------------------------------------------------------------
void IIR_3DNR(FILTER_PROC_INFO *fpip, FILTER *fp)
{
	int x,y;
	int y_str, y_str_temp, c_str, c_str_temp, threshold;
	int skip = fpip->max_w-fpip->w;
	PIXEL_YC *ycp = fpip->ycp_edit, 
			 *Bef_ycp = Bef_flame;
	y_str = y_str_temp = fp->track[0];
	c_str = c_str_temp = fp->track[1];
	threshold = fp->track[2];

	for(y=0;y<fpip->h;y++) {
		for(x=0;x<fpip->w;x++) {
			if(threshold)
				set_str(ycp, Bef_ycp, y_str, c_str, y_str_temp, c_str_temp, threshold);
			IIR_3DYNR(ycp->y, Bef_ycp->y, y_str_temp);
			if(c_str_temp){
				IIR_3DCNR(ycp->cb, Bef_ycp->cb, c_str_temp);
				IIR_3DCNR(ycp->cr, Bef_ycp->cr, c_str_temp);
			}
			ycp++;
			Bef_ycp++;
		}
		ycp += skip;
		Bef_ycp += skip;
	}
}
//---------------------------------------------------------------------
//		IIR_3DNR֐(ȈՔ)
//---------------------------------------------------------------------
void IIR_3DNR_Lite(FILTER_PROC_INFO *fpip, FILTER *fp)
{
	int x,y;
	int y_str_temp, c_str_temp;
	int skip = fpip->max_w-fpip->w;
	PIXEL_YC *ycp = fpip->ycp_edit, 
			 *Bef_ycp = Bef_flame;
	y_str_temp = fp->track[0];
	c_str_temp = fp->track[1];

	for(y=0;y<fpip->h;y++) {
		for(x=0;x<fpip->w;x++) {
			IIR_3DYNR(ycp->y, Bef_ycp->y, y_str_temp);
			IIR_3DCNR(ycp->cb, Bef_ycp->cb, c_str_temp);
			IIR_3DCNR(ycp->cr, Bef_ycp->cr, c_str_temp);
			ycp++;
			Bef_ycp++;
		}
		ycp += skip;
		Bef_ycp += skip;
	}
}
//---------------------------------------------------------------------
//		K^IIR_3DNR֐
//---------------------------------------------------------------------
void mvec_IIR_3DNR(FILTER_PROC_INFO *fpip, FILTER *fp, int* vx, int* vy, int search_mode)
{
	int x,y,x2;
	int y_str, y_str_temp, c_str, c_str_temp, threshold;
	int motion_vector;
	int skip = (search_mode==1) ? fpip->max_w-fpip->w : fpip->max_w-fpip->w+fpip->max_w;
	int speedup,
		speedup2 = fpip->w>>4;
	PIXEL_YC *ycp = fpip->ycp_edit, 
			 *Bef_ycp;
	y_str = y_str_temp = fp->track[0];
	c_str = c_str_temp = fp->track[1];
	threshold = fp->track[2];

	for(int i=0;i<search_mode;i++){
		for(y=i;y<fpip->h;y+=search_mode) {
			speedup = speedup2 * (y>>4);
			for(x=0;x<fpip->w;x+=16) {
				motion_vector = speedup + (x>>4);
				Bef_ycp = Bef_flame + ( y + vy[motion_vector] ) * fpip->max_w + ( x + vx[motion_vector]);

				for(x2=0;x2<16;x2++){
					if(threshold)
						set_str(ycp, Bef_ycp, y_str, c_str, y_str_temp, c_str_temp, threshold);
					IIR_3DYNR(ycp->y, Bef_ycp->y, y_str_temp);
					if(c_str_temp){
						IIR_3DCNR(ycp->cb, Bef_ycp->cb, c_str_temp);
						IIR_3DCNR(ycp->cr, Bef_ycp->cr, c_str_temp);
					}
					ycp++;
					Bef_ycp++;
				}

			}
			ycp += skip;
		}
		ycp = fpip->ycp_edit+fpip->max_w;
		vx += (fpip->w/16*fpip->h/16);
		vy += (fpip->w/16*fpip->h/16);
	}
}
//---------------------------------------------------------------------
//		L[t[֐
//---------------------------------------------------------------------
inline BOOL cheak_keyframe( int current_frame, void *editp, FILTER *fp )
{
	FRAME_STATUS fs;
	fp->exfunc->get_frame_status(editp,current_frame,&fs);
	return (fs.edit_flag % 2 != 0);
}
//---------------------------------------------------------------------
//		L[t[ݒ֐
//---------------------------------------------------------------------
inline void set_keyframe( int current_frame, void *editp, FILTER *fp )
{
	FRAME_STATUS fs;
	fp->exfunc->get_frame_status(editp,current_frame,&fs);
	fs.edit_flag = fs.edit_flag | 1;
	fp->exfunc->set_frame_status(editp,current_frame,&fs);
}

//ȉ̎O̊֐͓Kbp̂
//---------------------------------------------------------------------
//		t[ԋPx擾֐
//---------------------------------------------------------------------
void get_ydiff(FILTER_PROC_INFO *fpip, int *ydiff)
{
	int x,y;
	int skip = fpip->max_w-fpip->w;
	PIXEL_YC *ycp = fpip->ycp_edit, 
			 *Bef_ycp = Bef_flame;

	for(y=0;y<fpip->h;y++) {
		for(x=0;x<fpip->w;x++) {
			*ydiff = ycp->y - Bef_ycp->y;
			ycp++;
			Bef_ycp++;
			ydiff++;
		}
		ycp += skip;
		Bef_ycp += skip;
	}
}
//---------------------------------------------------------------------
//		t[ԋPx␳֐
//---------------------------------------------------------------------
void encode(int *diff, int H, int W, int threshold_correct)
{
	int x,y,x2,y2,y3;
	int* dp;
	int temp[NNN*NNN];
	int* tempP;
	int xsize = sizeof(int)*NNN;
	int threshold[16*16] = { 300, 1000, 1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140,
							1000, 1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150,
							1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160,
							1020, 1030, 1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170,
							1030, 1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180,
							1040, 1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190,
							1050, 1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200,
							1060, 1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210,
							1070, 1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220,
							1080, 1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230,
							1090, 1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240,
							1100, 1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240, 1250,
							1110, 1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240, 1250, 1260,
							1120, 1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240, 1250, 1260, 1270,
							1130, 1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240, 1250, 1260, 1270, 1280,
							1140, 1150, 1160, 1170, 1180, 1190, 1200, 1210, 1220, 1230, 1240, 1250, 1260, 1270, 1280, 1290,
							};
	int* threP;

//臒l␳B
	threP = threshold;
	for(int i=0;i<256;i++){
		*threP = (*threP*100 * threshold_correct) / 10000;
		threP++;
	}

//ȉAC
	for(y=0;y<H;y+=NNN) {
		for(x=0;x<W;x+=NNN) {

//NNN*NNN̗̈ɏ𕡐
			for(y2=0,y3=y*W+x;y2<NNN;y2++,y3+=W)
				memcpy(temp+y2*NNN, diff+y3, xsize);

//A_}[ϊ
			FWHT(temp);

//臒l傫Ȕg`͓Ɣfĕ␳Ă
			threP = threshold;
			tempP = temp;
			for(y2=0;y2<NNN*NNN;y2++) {
				if( *threP < abs(*tempP) )
					*tempP = (*tempP<0) ? 0-*threP : *threP;
				threP++;
				tempP++;
			}

//tA_}[ϊ
			FWHT(temp);

//߂
			tempP = temp;
			for(y2=0,y3=y*W+x;y2<NNN;y2++,y3+=W) {
				dp = diff + y3;
				for(x2=0;x2<NNN;x2++) {
//					*dp = *tempP/(NNN*NNN);	//Ɠ
					*dp = *tempP>>8;
					dp++;
					tempP++;
				}
			}

		}
	}
}
//---------------------------------------------------------------------
//		A_}[IIR_3DNR֐
//---------------------------------------------------------------------
void hadamard_IIR_3DNR(FILTER_PROC_INFO *fpip, FILTER *fp, int *ydiff)
{
	int x,y;
	int c_str_temp;
	int skip = fpip->max_w-fpip->w;
	PIXEL_YC *ycp = fpip->ycp_edit, 
			 *Bef_ycp = Bef_flame;
	c_str_temp = fp->track[1];

	for(y=0;y<fpip->h;y++) {
		for(x=0;x<fpip->w;x++) {
			ycp->y -= *ydiff;
			if(c_str_temp){
				IIR_3DCNR(ycp->cb, Bef_ycp->cb, c_str_temp);
				IIR_3DCNR(ycp->cr, Bef_ycp->cr, c_str_temp);
			}
			ycp++;
			Bef_ycp++;
			ydiff++;
		}
		ycp += skip;
		Bef_ycp += skip;
	}
}

//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//̃t[ł͂ȂA܂̓L[t[ȂNRpɎ̃t[ǂݍŏIB
	if( cheak_keyframe(fpip->frame, fpip->editp, fp) || FRAME+1 != fpip->frame){
//24fps΍ŁA̎̃t[łȂAOt[Ԉt[łȂ̃`FbNB
		if( !( FRAME+2 == fpip->frame && !(fp->exfunc->is_saveframe( fpip->editp, (fpip->frame==0) ? fpip->frame : fpip->frame-1 )) ) ){
			SET_YCbCr(fpip);
			FRAME = fpip->frame;
			Bef_motion_vector_total = -10;
			return TRUE;
		}
	}

//memcpy(fpip->ycp_temp, fpip->ycp_edit, sizeof(PIXEL_YC)*fpip->max_w*fpip->h);

	if(fp->track[3]) {

		int pict_struct = (fpip->h==480) ? FIELD_PICTURE : FRAME_PICTURE;
		int* vx = new int[(fpip->w/16)*(fpip->h/16)*2];	//xNgx
		int* vy = new int[(fpip->w/16)*(fpip->h/16)*2];	//xNgx
		unsigned char* current_pix = new unsigned char[fpip->w*fpip->h];	//8rbgɃVtgt[̋Px
		unsigned char* bef_pix = new unsigned char[fpip->w*fpip->h];	//8rbgɃVtgOt[̋Px

		shift_to_eight_bit( fpip->ycp_edit, current_pix, fpip->w,  fpip->max_w, fpip->h );
		shift_to_eight_bit( Bef_flame, bef_pix, fpip->w,  fpip->max_w, fpip->h );

		if( mvec( current_pix, bef_pix, vx, vy, fpip->w, fpip->h, (100-fp->track[3])*(100/pict_struct), pict_struct, fp->track[4] ) ){
//V[`FWȂ΃L[t[ݒ肵ďIB
			if(fp->check[0])
				set_keyframe(fpip->frame, fpip->editp, fp);
			Bef_motion_vector_total = -10;
		} else {
			mvec_IIR_3DNR(fpip, fp, vx, vy, pict_struct);
		}

		delete[] vx;
		delete[] vy;
		delete[] current_pix;
		delete[] bef_pix;

	} else if(fp->track[5]) {

		int* ydiff = new int[fpip->w*fpip->h];	//Px̃t[ԍ

		get_ydiff(fpip, ydiff);
		encode(ydiff, fpip->h, fpip->w, fp->track[5]);
		hadamard_IIR_3DNR(fpip, fp, ydiff);

		delete[] ydiff;

	} else {

		if(fp->track[1] && !fp->track[2])
			IIR_3DNR_Lite(fpip, fp);	//臒l&FNR̍
		else
			IIR_3DNR(fpip, fp);

	}

	FRAME = fpip->frame;
	memcpy(Bef_flame, fpip->ycp_edit, sizeof(PIXEL_YC)*fpip->max_w*fpip->h);
//memcpy(Bef_flame, fpip->ycp_temp, sizeof(PIXEL_YC)*fpip->max_w*fpip->h);

	return TRUE;
}
//---------------------------------------------------------------------
//		EBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
//t@CVJALĂt[ԍNA
	switch(message){
	case WM_FILTER_FILE_OPEN:
		FRAME = -10;
	}

	return FALSE;
}

